#if !defined(AST_MANAGER_HH)
#define AST_MANAGER_HH

#include <iostream>

#include "AstNode.hh"

///////////////////////////////////////////////////////////////////////////
class AstManager {
///////////////////////////////////////////////////////////////////////////

public : 

  AstManager( void ) { }
  ~AstManager( void ) { }

  // Resource Management
  AstNode* newOperator( void ) {
    AstNode* n = new Operator();
    return n;
  }
  AstNode* newOperand( void ) {
    AstNode* n = new Operand();
    return n;
  }
  void free( AstNode* n ) {
    delete(n);
  }

  // Utilities
  virtual void print( std::ostream& ofs, AstNode* n ) {
    if (n->isOperand()) {
      ofs << n->getValue();
    } else { // n->is Operator
      ofs << "(";
      print(ofs, n->getOperand(AstNode::LEFT));
      switch (n->getOpType()) {
      case AstNode::PLUS : ofs << "+"; break;
      case AstNode::MINUS : ofs << "-"; break;
      case AstNode::TIMES : ofs << "*"; break;
      case AstNode::FRAC : ofs << "/"; break;
      default : ofs << "?"; break;
      }
      print(ofs,n->getOperand(AstNode::RIGHT));
      ofs << ")";
    }
  }
  void printLine( std::ostream& ofs, AstNode* n ) {
    print(ofs, n);
    ofs << std::endl;
  }

}; // End of class AstManager

#endif
